package com.appiancorp.ps.sail.type;

import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

import com.appiancorp.suiteapi.common.paging.DataSubset;
import com.appiancorp.suiteapi.common.paging.PagingInfo;

@XmlType(name="PortalReportDataSubset", namespace="http://types.appiancorp.com/ps", propOrder = {
	"startIndex",
	"batchSize",
	"sort",
	"totalCount",
	"data",
	"identifiers",
	"report",
	"columns"
})
public class PortalReportDataSubset extends DataSubset<PortalReportColumnData, Long> {
	private List<PortalReportColumnData> data;
	private List<Long> identifiers;
	private PortalReport report;
	private List<PortalReportColumn> columns;

	public PortalReportDataSubset() {
		super();
	}

	public PortalReportDataSubset(PagingInfo pagingInfo, int totalCount, List<PortalReportColumnData> data, List<Long> identifiers, PortalReport report, List<PortalReportColumn> columns) {
		super(pagingInfo.getStartIndex(), pagingInfo.getBatchSize(), pagingInfo.getSort(), totalCount, data, identifiers);

		this.report = report;
		this.columns = columns;
	}

	@Override
	@XmlElement
	public List<PortalReportColumnData> getData() {
		return data;
	}

	@Override
	@XmlElement
	public List<Long> getIdentifiers() {
		return identifiers;
	}

	@XmlElement
	public PortalReport getReport() {
		return report;
	}

	@XmlElement
	public List<PortalReportColumn> getColumns() {
		return columns;
	}

	@Override
	protected void setData(List<PortalReportColumnData> data) {
		this.data = data;
	}

	@Override
	protected void setIdentifiers(List<Long> identifiers) {
		this.identifiers = identifiers;
	}

	protected void setReport(PortalReport report) {
		this.report = report;
	}

	protected void setColumns(List<PortalReportColumn> columns) {
		this.columns = columns;
	}
}
